Index: pjproject/trunk/pjsip-apps/src/python/_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2158)
+++ pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2163)
@@ -4203,375 +3005,15 @@
 
 /*
- * PyObj_pj_time_val
- * PJ Time Val
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    long sec;
-    long msec;
-
-} PyObj_pj_time_val;
-
-
-
-/*
- * pj_time_val_members
- */
-static PyMemberDef pj_time_val_members[] =
-{   
-    
-    {
-        "sec", T_INT, 
-        offsetof(PyObj_pj_time_val, sec), 0,
-        "The seconds part of the time"
-    },
-    {
-        "msec", T_INT, 
-        offsetof(PyObj_pj_time_val, sec), 0,
-        "The milliseconds fraction of the time"
-    },
-    
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pj_time_val
- */
-static PyTypeObject PyTyp_pj_time_val =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.PJ_Time_Val",      /*tp_name*/
-    sizeof(PyObj_pj_time_val),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "PJ Time Val objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    pj_time_val_members,         /* tp_members */
-    
-
-};
-
-/*
- * PyObj_pjsua_call_info
- * Call Info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */ 
-    
-    int id;
-    int role;
-    int acc_id;
-    PyObject * local_info;
-    PyObject * local_contact;
-    PyObject * remote_info;
-    PyObject * remote_contact;
-    PyObject * call_id;
-    int state;
-    PyObject * state_text;
-    int last_status;
-    PyObject * last_status_text;
-    int media_status;
-    int media_dir;
-    int conf_slot;
-    PyObj_pj_time_val * connect_duration;
-    PyObj_pj_time_val * total_duration;
-    struct {
-	char local_info[128];
-	char local_contact[128];
-	char remote_info[128];
-	char remote_contact[128];
-	char call_id[128];
-	char last_status_text[128];
-    } buf_;
-
-} PyObj_pjsua_call_info;
-
-
-/*
- * call_info_dealloc
- * deletes a call_info from memory
- */
-static void call_info_dealloc(PyObj_pjsua_call_info* self)
-{
-    Py_XDECREF(self->local_info);
-    Py_XDECREF(self->local_contact);
-    Py_XDECREF(self->remote_info);
-    Py_XDECREF(self->remote_contact);
-    Py_XDECREF(self->call_id);
-    Py_XDECREF(self->state_text);
-    Py_XDECREF(self->last_status_text);
-    Py_XDECREF(self->connect_duration);
-    Py_XDECREF(self->total_duration);
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * call_info_new
- * constructor for call_info object
- */
-static PyObject * call_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    PyObj_pjsua_call_info *self;
-
-    PJ_UNUSED_ARG(args);
-    PJ_UNUSED_ARG(kwds);
-
-    self = (PyObj_pjsua_call_info *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->local_info = PyString_FromString("");
-        if (self->local_info == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }       
-	self->local_contact = PyString_FromString("");
-        if (self->local_contact == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->remote_info = PyString_FromString("");
-        if (self->remote_info == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->remote_contact = PyString_FromString("");
-        if (self->remote_contact == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->call_id = PyString_FromString("");
-        if (self->call_id == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->state_text = PyString_FromString("");
-        if (self->state_text == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->last_status_text = PyString_FromString("");
-        if (self->last_status_text == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->connect_duration = (PyObj_pj_time_val *)PyType_GenericNew
-	    (&PyTyp_pj_time_val,NULL,NULL);
-        if (self->connect_duration == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->total_duration = (PyObj_pj_time_val *)PyType_GenericNew
-	    (&PyTyp_pj_time_val,NULL,NULL);
-        if (self->total_duration == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-    }
-    return (PyObject *)self;
-}
-
-/*
- * call_info_members
- */
-static PyMemberDef call_info_members[] =
-{   
-    {
-        "id", T_INT, 
-        offsetof(PyObj_pjsua_call_info, id), 0,
-        "Call identification"
-    },
-    {
-        "role", T_INT, 
-        offsetof(PyObj_pjsua_call_info, role), 0,
-        "Initial call role (UAC == caller)"
-    },
-    {
-        "acc_id", T_INT, 
-        offsetof(PyObj_pjsua_call_info, acc_id), 0,
-        "The account ID where this call belongs."
-    },
-    {
-        "local_info", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, local_info), 0,
-        "Local URI"        
-    },
-    {
-        "local_contact", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, local_contact), 0,
-        "Local Contact"        
-    },
-    {
-        "remote_info", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, remote_info), 0,
-        "Remote URI"        
-    },
-    {
-        "remote_contact", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, remote_contact), 0,
-        "Remote Contact"        
-    },
-    {
-        "call_id", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, call_id), 0,
-        "Dialog Call-ID string"        
-    },
-    {
-        "state", T_INT, 
-        offsetof(PyObj_pjsua_call_info, state), 0,
-        "Call state"
-    },
-    {
-        "state_text", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, state_text), 0,
-        "Text describing the state "        
-    },
-    {
-        "last_status", T_INT, 
-        offsetof(PyObj_pjsua_call_info, last_status), 0,
-        "Last status code heard, which can be used as cause code"
-    },
-    {
-        "last_status_text", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, last_status_text), 0,
-        "The reason phrase describing the status."        
-    },
-    {
-        "media_status", T_INT, 
-        offsetof(PyObj_pjsua_call_info, media_status), 0,
-        "Call media status."
-    },
-    {
-        "media_dir", T_INT, 
-        offsetof(PyObj_pjsua_call_info, media_dir), 0,
-        "Media direction"
-    },
-    {
-        "conf_slot", T_INT, 
-        offsetof(PyObj_pjsua_call_info, conf_slot), 0,
-        "The conference port number for the call"
-    },
-    {
-        "connect_duration", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, connect_duration), 0,
-        "Up-to-date call connected duration(zero when call is not established)"
-    },
-    {
-        "total_duration", T_OBJECT_EX,
-        offsetof(PyObj_pjsua_call_info, total_duration), 0,
-        "Total call duration, including set-up time"        
-    },
-    
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * PyTyp_pjsua_call_info
- */
-static PyTypeObject PyTyp_pjsua_call_info =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "_pjsua.Call_Info",      /*tp_name*/
-    sizeof(PyObj_pjsua_call_info),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)call_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Call Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    call_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    call_info_new,             /* tp_new */
-
-};
-
-/*
  * py_pjsua_call_get_max_count
  */
-static PyObject *py_pjsua_call_get_max_count
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_get_max_count(PyObject *pSelf, PyObject *pArgs)
 {    	
     int count;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     count = pjsua_call_get_max_count();
     
-    
     return Py_BuildValue("i", count);
 }
@@ -4580,20 +3022,13 @@
  * py_pjsua_call_get_count
  */
-static PyObject *py_pjsua_call_get_count
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_get_count(PyObject *pSelf, PyObject *pArgs)
 {    	
-    
     int count;	
     
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     count = pjsua_call_get_count();
     
-    
     return Py_BuildValue("i", count);
 }
@@ -4605,30 +3040,22 @@
 {
     pj_status_t status;
-    PyObject *list;
-    
+    PyObject *ret;
     pjsua_transport_id id[PJSUA_MAX_CALLS];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(id);
     status = pjsua_enum_calls(id, &c);
-    
-    list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {     
-        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-        if (ret == -1) 
-        {
-            return NULL;
-        }
-    }
-    
-    return Py_BuildValue("O",list);
+    if (status != PJ_SUCCESS)
+	c = 0;
+    
+    ret = PyList_New(c);
+    for (i = 0; i < c; i++)  {     
+        PyList_SetItem(ret, i, Py_BuildValue("i", id[i]));
+    }
+    
+    return (PyObject*)ret;
 }
 
@@ -4636,50 +3063,49 @@
  * py_pjsua_call_make_call
  */
-static PyObject *py_pjsua_call_make_call
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_make_call(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
     int acc_id;
     pj_str_t dst_uri;
-    PyObject * sd;
+    PyObject *pDstUri, *pMsgData, *pUserData;
     unsigned options;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;
-    int user_data;
     int call_id;
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple
-		(pArgs, "iOIiO", &acc_id, &sd, &options, &user_data, &omdObj))
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iOIOO", &acc_id, &pDstUri, &options, 
+			  &pUserData, &pMsgData))
     {
         return NULL;
     }
 	
-    dst_uri.ptr = PyString_AsString(sd);
-    dst_uri.slen = strlen(PyString_AsString(sd));
-    if (omdObj != Py_None) 
-    {
-        omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+    dst_uri = PyString_ToPJ(pDstUri);
+    pjsua_msg_data_init(&msg_data);
+
+    if (pMsgData != Py_None) {
+	PyObj_pjsua_msg_data * omd;
+
+        omd = (PyObj_pjsua_msg_data *)pMsgData;
+
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_make_call(acc_id, &dst_uri, 
-			options, (void*)user_data, &msg_data, &call_id);	
-        pj_pool_release(pool);
-    } else {
-		
-        status = pjsua_call_make_call(acc_id, &dst_uri, 
-			options, (void*)user_data, NULL, &call_id);	
-    }
-	
-    return Py_BuildValue("ii",status, call_id);
-	
+    }
+
+    Py_XINCREF(pUserData);
+
+    status = pjsua_call_make_call(acc_id, &dst_uri, 
+				  options, (void*)pUserData, 
+				  &msg_data, &call_id);	
+    if (pool != NULL)
+	pj_pool_release(pool);
+    
+    if (status != PJ_SUCCESS)
+    	Py_XDECREF(pUserData);
+
+    return Py_BuildValue("ii", status, call_id);	
 }
 
@@ -4687,21 +3113,18 @@
  * py_pjsua_call_is_active
  */
-static PyObject *py_pjsua_call_is_active
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_is_active(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
-    int isActive;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &call_id))
-    {
+    int is_active;
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &call_id)) {
         return NULL;
     }	
     
-    isActive = pjsua_call_is_active(call_id);
-    
-    
-    return Py_BuildValue("i", isActive);
+    is_active = pjsua_call_is_active(call_id);
+    
+    return Py_BuildValue("i", is_active);
 }
 
@@ -4709,21 +3132,18 @@
  * py_pjsua_call_has_media
  */
-static PyObject *py_pjsua_call_has_media
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_has_media(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
-    int hasMedia;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &call_id))
-    {
+    int has_media;
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &call_id)) {
         return NULL;
     }	
     
-    hasMedia = pjsua_call_has_media(call_id);
-    
-    
-    return Py_BuildValue("i", hasMedia);
+    has_media = pjsua_call_has_media(call_id);
+
+    return Py_BuildValue("i", has_media);
 }
 
@@ -4731,20 +3151,17 @@
  * py_pjsua_call_get_conf_port
  */
-static PyObject *py_pjsua_call_get_conf_port
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject* py_pjsua_call_get_conf_port(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
-    int port_id;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &call_id))
-    {
-        return NULL;
-    }	
-    
+    int port_id;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &call_id)) {
+        return NULL;
+    }
+
     port_id = pjsua_call_get_conf_port(call_id);
-    
-    
+
     return Py_BuildValue("i", port_id);
 }
@@ -4753,71 +3170,51 @@
  * py_pjsua_call_get_info
  */
-static PyObject *py_pjsua_call_get_info
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject* py_pjsua_call_get_info(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
     int status;
-    PyObj_pjsua_call_info * oi;
+    PyObj_pjsua_call_info *ret;
     pjsua_call_info info;
     
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &call_id))
-    {
+    if (!PyArg_ParseTuple(pArgs, "i", &call_id)) {
         return NULL;
     }	
     
-    
     status = pjsua_call_get_info(call_id, &info);
-    if (status == PJ_SUCCESS) 
-    {
-        oi = (PyObj_pjsua_call_info *)call_info_new(&PyTyp_pjsua_call_info, NULL, NULL);
-        oi->acc_id = info.acc_id;
-        pj_ansi_snprintf(oi->buf_.call_id, sizeof(oi->buf_.call_id),
-	    "%.*s", (int)info.call_id.slen, info.call_id.ptr);
-        pj_ansi_snprintf(oi->buf_.last_status_text, 
-	    sizeof(oi->buf_.last_status_text),
-	    "%.*s", (int)info.last_status_text.slen, info.last_status_text.ptr);
-        pj_ansi_snprintf(oi->buf_.local_contact, sizeof(oi->buf_.local_contact),
-	    "%.*s", (int)info.local_contact.slen, info.local_contact.ptr);
-        pj_ansi_snprintf(oi->buf_.local_info, sizeof(oi->buf_.local_info),
-	    "%.*s", (int)info.local_info.slen, info.local_info.ptr);
-        pj_ansi_snprintf(oi->buf_.remote_contact,
-	    sizeof(oi->buf_.remote_contact),
-	    "%.*s", (int)info.remote_contact.slen, info.remote_contact.ptr);
-        pj_ansi_snprintf(oi->buf_.remote_info, sizeof(oi->buf_.remote_info),
-	    "%.*s", (int)info.remote_info.slen, info.remote_info.ptr);
-
-        oi->call_id = PyString_FromStringAndSize(info.call_id.ptr, 
-	    info.call_id.slen);
-        oi->conf_slot = info.conf_slot;
-        oi->connect_duration->sec = info.connect_duration.sec;
-        oi->connect_duration->msec = info.connect_duration.msec;
-        oi->total_duration->sec = info.total_duration.sec;
-        oi->total_duration->msec = info.total_duration.msec;
-        oi->id = info.id;
-        oi->last_status = info.last_status;
-        oi->last_status_text = PyString_FromStringAndSize(
-	    info.last_status_text.ptr, info.last_status_text.slen);
-        oi->local_contact = PyString_FromStringAndSize(
-	    info.local_contact.ptr, info.local_contact.slen);
-        oi->local_info = PyString_FromStringAndSize(
-   	    info.local_info.ptr, info.local_info.slen);
-        oi->remote_contact = PyString_FromStringAndSize(
-	    info.remote_contact.ptr, info.remote_contact.slen);
-        oi->remote_info = PyString_FromStringAndSize(
-	    info.remote_info.ptr, info.remote_info.slen);
-        oi->media_dir = info.media_dir;
-        oi->media_status = info.media_status;
-        oi->role = info.role;
-        oi->state = info.state;
-        oi->state_text = PyString_FromStringAndSize(
-   	    info.state_text.ptr, info.state_text.slen);
-
-	return Py_BuildValue("O", oi);
-    } else {
-	Py_INCREF(Py_None);
-	return Py_None;
-    }
+    if (status != PJ_SUCCESS)
+	return Py_BuildValue("");
+
+    ret = (PyObj_pjsua_call_info *)call_info_new(&PyTyp_pjsua_call_info,
+						 NULL, NULL);
+    ret->acc_id = info.acc_id;
+    Py_XDECREF(ret->call_id);
+    ret->call_id = PyString_FromPJ(&info.call_id);
+    ret->conf_slot = info.conf_slot;
+    ret->connect_duration = info.connect_duration.sec * 1000 +
+			    info.connect_duration.msec;
+    ret->total_duration = info.total_duration.sec * 1000 +
+			  info.total_duration.msec;
+    ret->id = info.id;
+    ret->last_status = info.last_status;
+    Py_XDECREF(ret->last_status_text);
+    ret->last_status_text = PyString_FromPJ(&info.last_status_text);
+    Py_XDECREF(ret->local_contact);
+    ret->local_contact = PyString_FromPJ(&info.local_contact);
+    Py_XDECREF(ret->local_info);
+    ret->local_info = PyString_FromPJ(&info.local_info);
+    Py_XDECREF(ret->remote_contact);
+    ret->remote_contact = PyString_FromPJ(&info.remote_contact);
+    Py_XDECREF(ret->remote_info);
+    ret->remote_info = PyString_FromPJ(&info.remote_info);
+    ret->media_dir = info.media_dir;
+    ret->media_status = info.media_status;
+    ret->role = info.role;
+    ret->state = info.state;
+    Py_XDECREF(ret->state_text);
+    ret->state_text = PyString_FromPJ(&info.state_text);
+
+    return (PyObject*)ret;
 }
 
@@ -4825,21 +3222,30 @@
  * py_pjsua_call_set_user_data
  */
-static PyObject *py_pjsua_call_set_user_data
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_set_user_data(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
-    int user_data;	
+    PyObject *pUserData, *old_user_data;
     int status;
 
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &call_id, &user_data))
-    {
-        return NULL;
-    }	
-    
-    status = pjsua_call_set_user_data(call_id, (void*)user_data);
-    
-    
+    if (!PyArg_ParseTuple(pArgs, "iO", &call_id, &pUserData)) {
+        return NULL;
+    }
+
+    old_user_data = (PyObject*) pjsua_call_get_user_data(call_id);
+
+    if (old_user_data == pUserData) {
+	return Py_BuildValue("i", PJ_SUCCESS);
+    }
+
+    Py_XINCREF(pUserData);
+    Py_XDECREF(old_user_data);
+
+    status = pjsua_call_set_user_data(call_id, (void*)pUserData);
+    
+    if (status != PJ_SUCCESS)
+    	Py_XDECREF(pUserData);
+
     return Py_BuildValue("i", status);
 }
@@ -4848,21 +3254,17 @@
  * py_pjsua_call_get_user_data
  */
-static PyObject *py_pjsua_call_get_user_data
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_get_user_data(PyObject *pSelf, PyObject *pArgs)
 {    	
     int call_id;
-    void * user_data;	
-    
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "i", &call_id))
-    {
+    PyObject *user_data;	
+    
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &call_id)) {
         return NULL;
     }	
     
-    user_data = pjsua_call_get_user_data(call_id);
-    
-    
-    return Py_BuildValue("i", (int)user_data);
+    user_data = (PyObject*)pjsua_call_get_user_data(call_id);
+    return user_data ? Py_BuildValue("O", user_data) : Py_BuildValue("");
 }
 
@@ -4870,52 +3272,45 @@
  * py_pjsua_call_answer
  */
-static PyObject *py_pjsua_call_answer
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_answer(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
     int call_id;
     pj_str_t * reason, tmp_reason;
-    PyObject * sr;
+    PyObject *pReason;
     unsigned code;
     pjsua_msg_data msg_data;
     PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iIOO", &call_id, &code, &sr, &omdObj))
-    {
-        return NULL;
-    }
-    if (sr == Py_None) 
-    {
+    pj_pool_t * pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iIOO", &call_id, &code, &pReason, &omdObj)) {
+        return NULL;
+    }
+
+    if (pReason == Py_None) {
         reason = NULL;
     } else {
 	reason = &tmp_reason;
-        tmp_reason.ptr = PyString_AsString(sr);
-        tmp_reason.slen = strlen(PyString_AsString(sr));
-    }
-    if (omdObj != Py_None) 
-    {
+        tmp_reason = PyString_ToPJ(pReason);
+    }
+
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-	
-        status = pjsua_call_answer(call_id, code, reason, &msg_data);	
-    
-        pj_pool_release(pool);
-    } else {
-	
-        status = pjsua_call_answer(call_id, code, reason, NULL);
-	
-    }
-    
-    return Py_BuildValue("i",status);
+    }
+    
+    status = pjsua_call_answer(call_id, code, reason, &msg_data);	
+
+    if (pool)
+	pj_pool_release(pool);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -4923,48 +3318,46 @@
  * py_pjsua_call_hangup
  */
-static PyObject *py_pjsua_call_hangup
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_hangup(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
     int call_id;
-    pj_str_t * reason, tmp_reason;
-    PyObject * sr;
+    pj_str_t *reason, tmp_reason;
+    PyObject *pReason;
     unsigned code;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool = NULL;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iIOO", &call_id, &code, &sr, &omdObj))
-    {
-        return NULL;
-    }
-    if (sr == Py_None)
-    {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iIOO", &call_id, &code, &pReason, 
+			  &omdObj))
+    {
+        return NULL;
+    }
+
+    if (pReason == Py_None) {
         reason = NULL;
     } else {
         reason = &tmp_reason;
-        tmp_reason.ptr = PyString_AsString(sr);
-        tmp_reason.slen = strlen(PyString_AsString(sr));
-    }
-    if (omdObj != Py_None) 
-    {
+        tmp_reason = PyString_ToPJ(pReason);
+    }
+
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None)  {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_hangup(call_id, code, reason, &msg_data);	
-        pj_pool_release(pool);
-    } else {
-        status = pjsua_call_hangup(call_id, code, reason, NULL);	
-    }
-    
-    return Py_BuildValue("i",status);
+    }
+    
+    status = pjsua_call_hangup(call_id, code, reason, &msg_data);
+    if (pool)
+	pj_pool_release(pool);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -4972,36 +3365,34 @@
  * py_pjsua_call_set_hold
  */
-static PyObject *py_pjsua_call_set_hold
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_set_hold(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
     int call_id;    
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iO", &call_id, &omdObj))
-    {
-        return NULL;
-    }
-
-    if (omdObj != Py_None) 
-    {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iO", &call_id, &omdObj)) {
+        return NULL;
+    }
+
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;    
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_set_hold(call_id, &msg_data);	
+    }
+
+    status = pjsua_call_set_hold(call_id, &msg_data);
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_set_hold(call_id, NULL);	
-    }
+
     return Py_BuildValue("i",status);
 }
@@ -5010,38 +3401,36 @@
  * py_pjsua_call_reinvite
  */
-static PyObject *py_pjsua_call_reinvite
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_reinvite(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
-    int call_id;    
+    int call_id;
     int unhold;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;    
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iiO", &call_id, &unhold, &omdObj))
-    {
-        return NULL;
-    }
-
-    if (omdObj != Py_None)
-    {
+    PyObject *omdObj;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iiO", &call_id, &unhold, &omdObj)) {
+        return NULL;
+    }
+
+    pjsua_msg_data_init(&msg_data);
+    if (omdObj != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
         omd = (PyObj_pjsua_msg_data *)omdObj;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = strlen
-			(PyString_AsString(omd->content_type));
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = strlen(PyString_AsString(omd->msg_body));
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_call_reinvite(call_id, unhold, &msg_data);	
+    }
+
+    status = pjsua_call_reinvite(call_id, unhold, &msg_data);
+
+    if (pool)
         pj_pool_release(pool);
-    } else {
-        status = pjsua_call_reinvite(call_id, unhold, NULL);
-    }
-    return Py_BuildValue("i",status);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -5049,6 +3438,5 @@
  * py_pjsua_call_update
  */
-static PyObject *py_pjsua_call_update
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_call_update(PyObject *pSelf, PyObject *pArgs)
 {    
     int status;
